unit SakEmail;
{

    SakEmail components Version 1.5.2
    Copyright  1997, 1998 Dr.K
    Sergio Kessler
    email: sergio@perio.unlp.edu.ar
    web: http://www.perio.unlp.edu.ar/~sergio


        Well, I developed this components because I hate OCX's (NetManage's
        very included).

        So, I decided to develop my own components (my first components -Wow !)
        and release it under the GNU public licensee (GPL).

	IMPORTANT: this update only work with Delphi own Sockets, I develop
	this with Delphi 3.0 c/s, but must work also with Delphi 3.01 pro and
	Delphi 3.01 c/s and above.

        Thanks also to Tony BenBrahim for his base64 routines (wich I modified
        a bit to fit in this project), because the mines are too slow.
	Also I ripped the UUDecode alghoritm, I don't know the author.

        And thanks to all the Delphi community.
        What marvelous people ! (like the product)

Legal stuff:

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the author be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented, you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

  3. I you make changes to this software, you MUST send me the modified
     version.

  4. This notice may not be removed or altered from any source distribution.

}

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WinSock, scktcomp;

type

  TSessionState = ( Authorization, Transaction);
  TOnError = procedure(Sender: TObject; Error: integer; Msg: string) of object;
  TOnReadEvent = procedure( Sender: TObject; BytesRead: integer) of object;
  TOnCodeStartEvent = procedure( Sender: TObject; FileName: string; BytesCount: longint) of object;
  TOnCodeProgressEvent = procedure( Sender: TObject; Percent: word) of object;
  TOnSendProgressEvent = procedure( Sender: TObject; Percent: word) of object;
  TOnDeleteEvent = procedure( Sender: TObject; id: word) of object;
  TOnBeforeRetrieve = procedure( sender: TObject; id: word) of object;

  TSakMsg = class;

  TAttachedFile  = class( TCollectionItem)
  private
    FFileName: string;
    FBodyEncoded: TStringList;
    FBodyBin: TMemoryStream;
    FMIMEType: string;
  protected
  public
    constructor Create( Collection: TCollection); override;
    procedure SaveToFile( fn: string);
    property FileName: string read FFileName write FFileName;
    property MIMEType: string read FMIMEType;
  end;

  TAttachedFiles = class( TCollection)
  private
    FSakMsg: TSakMsg;
    function GetItem( index: integer): TAttachedFile;
    procedure SetItem( index: integer; value: TAttachedFile);
    function FGetMIMEType( const FileName: string): string;
  public
    constructor Create( SakMsg: TSakMsg);
    function Add( fn: string): TAttachedFile;
    property Items[ index: integer]: TAttachedFile read GetItem write SetItem; default;
  end;

{=============== SakMsg ===============}

  TSakMsg = class(TComponent)
  private
    { Private declarations }
    FUserName: string;
    FFrom: string;
    FMessageId: string;
    FInReplyTo: string;
    FReplyTo: string;
    FSendTo: string;
    FDate: string;
    FSubject: string;
    FText: TStringList;
    FAttachedFiles: TAttachedFiles;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    destructor Destroy; override;
    property AttachedFiles: TAttachedFiles read FAttachedFiles write FAttachedFiles;
    property Date: string read FDate;
    property MessageId: string read FMessageId;
    property InReplyTo: string read FInReplyTo write FInReplyTo;
  published
    { Published declarations }
    property UserName: string read FUserName write FUserName;
    property From: string read FFrom write FFrom;
    property ReplyTo: string read FReplyTo write FReplyTo;
    property SendTo: string read FSendTo write FSendTo;
    property Subject: string read FSubject write FSubject;
    property Text: TStringList read FText write FText;
  end;


{=============== SakMsgList ===============}

  TSakMsgList = class(TComponent)
  private
    { Private declarations }
    Flist: TList;
    function GetCount: integer;
  protected
    { Protected declarations }
    function  Get(Index: Integer): TsakMsg;
    procedure Put(Index: Integer; Item: TsakMsg);
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Clear;
    function  Add(Item: TsakMsg): Integer;
    procedure Delete(Index: Integer);
    function  First: TsakMsg;
    function  IndexOf(Item: TsakMsg): Integer;
    procedure Insert(Index: Integer; Item: TsakMsg);
    function  Last: TsakMsg;
    function  Remove(Item: TsakMsg): Integer;
    property  Items[ index: integer]: TSakMsg read Get write Put; default;
    property  Count: integer read GetCount;
  end;


{=============== SakSMTP ===============}

  TSakSMTP = class(TComponent)
  private
    { Private declarations }
    FSocket: TClientSocket;
    FSocketStream: TWinSocketStream;

    FPort: string;
    FHost: String;
    FSMTPError: boolean;
    FConnected: boolean;
    FReplyCode: string;
    FReplyString: string;
    FSendProgress: word;
    FSendProgressStep: word;
    FEncodeProgress: word;
    FEncodeProgressStep: word;
    FCanceled: boolean;

    FOnConnect: TNotifyEvent;
    FOnDisconnect: TNotifyEvent;
    FOnBeforeSend: TNotifyEvent;
    FOnAfterSend: TNotifyEvent;
    FOnError: TOnError;
    FOnSendProgress: TOnSendProgressEvent;
    FOnEncodeStart: TOnCodeStartEvent;
    FOnEncodeProgress: TOnCodeProgressEvent;
    FOnEncodeEnd: TNotifyEvent;

    procedure FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoError( Sender: TObject; Socket: TCustomWinSocket;
                        ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FDoErr( ErrorEvent: TErrorEvent);
    procedure FDoEncodeStart( FileName: string; Size: longint);
    procedure FDoEncodeProgress( Percent: word);
    procedure FDoEncodeEnd;
    procedure FDoSendProgress( Percent: word);
    procedure DoOnBeforeSend;
    procedure DoOnAfterSend;
    function  FMakeUniqueID: string;
    function  FPrepareText( var aMsg: TSakMsg): TStringList;
    function  FGenerateBoundary : string;
    function  FReceiveTextFromSocket: string;
    procedure FSendTextToSocket( const txt: string);
  protected
    { Protected declarations }
    procedure Base64Encode( var AttachedFile: TAttachedFile);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Connect;
    procedure Quit;
    function  SendMessage( var aMsg: TSakMsg): boolean;
    property  Connected: boolean read FConnected;
    property  ReplyCode: string read FReplyCode;
    property  ReplyString: string read FReplyString;
    property  SMTPError: boolean read FSMTPError;
    property  Canceled: boolean read FCanceled write FCanceled;
  published
    { Published declarations }
    property  Port: string read FPort write FPort;
    property  Host: string read FHost write FHost;
    property  EncodeProgressStep: word read FEncodeProgressStep write FEncodeProgressStep;
    property  SendProgressStep: word read FSendProgressStep write FSendProgressStep;
    property  OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
    property  OnQuit: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property  OnError: TOnError read FOnError write FOnError;
    property  OnBeforeSend: TNotifyEvent read FOnBeforeSend write FOnBeforeSend;
    property  OnAfterSend: TNotifyEvent read FOnAfterSend write FOnAfterSend;
    property  OnEncodeStart: TOnCodeStartEvent read FOnEncodeStart write FOnEncodeStart;
    property  OnEncodeProgress: TOnCodeProgressEvent read FOnEncodeProgress write FOnEncodeProgress;
    property  OnEncodeEnd: TNotifyEvent read FOnEncodeEnd write FOnEncodeEnd;
    property  OnSendProgress: TOnSendProgressEvent read FOnSendProgress write FOnSendProgress;
  end;


{=============== SakPOP ===============}

  TSakPOP = class(TComponent)
  private
    { Private declarations }
    FSocket: TClientSocket;
    FSocketStream: TWinSocketStream;
    FSessionState: TSessionState;
    FUserId: string;
    FPasswd: string;
    FPort: string;
    FHost: String;
    FPOPError: boolean;
    FPOPErrorString: string;
    FConnected: boolean;
    FReceivingMsg: boolean;
    FSize: longint;
    FStep: word;
    FReplyCode: string;
    FReplyString: string;
    FCanceled: boolean;

    FDecodeProgress: word;
    FDecodeProgressStep: word;
    FRetrieveProgress: word;
    FRetrieveProgressStep: word;
    FMessagesDeleted: TStringList;
    FMsgsCount: word;

    FOnConnect: TNotifyEvent;
    FOnDisconnect: TNotifyEvent;
    FOnError: TOnError;
    FOnDecodeStart: TOnCodeStartEvent;
    FOnDecodeProgress: TOnCodeProgressEvent;
    FOnDecodeEnd: TNotifyEvent;
    FOnBeforeRetrieve: TOnBeforeRetrieve;
    FOnAfterRetrieve: TNotifyEvent;
    FOnRetrieveProgress: TOnCodeProgressEvent;
    FOnDelete: TOnDeleteEvent;

    procedure FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoErr( err: integer);
    procedure FDoError( Sender: TObject; Socket: TCustomWinSocket;
                        ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FDoDecodeStart( FileName: string; BytesCount: longint);
    procedure FDoDecodeProgress( Percent: word);
    procedure FDoRetrieveProgress( Percent: word);
    procedure FDoDelete( id: word);
    procedure FDoDecodeEnd;
    procedure FDoBeforeRetrieve( id: word);
    procedure FDoAfterRetrieve;
    function  FindInHeaders( const que: string; const strList: TStringList;
                             var line: integer): boolean;
    function  FindInStringList( const que: string; const strList: TStringList;
                                var line, position: integer): boolean;
    function  FindInStringListCS( const que: string; const strList: TStringList;
                                  var line, position: integer): boolean;
    function  FindUUAttachs( const strList: TStringList;
                             var line: integer;
                             var FileName: string): boolean;
    function  FReceiveTextFromSocket: string;
    procedure FSendTextToSocket( const txt: string);
  protected
    { Protected declarations }
    procedure Base64Decode( var AttachedFile: TAttachedFile);
    procedure UUDecode( var AttachedFile: TAttachedFile);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Connect;
    function  Login: boolean;
    function  Init: word;
    function  RetrieveMessage( id : word): TSakMsg;
    function  RetrieveAllMessages( var SakMsgList: TSakMsgList): integer;
    function  RetrieveHeaders( id : word): string;
    procedure DeleteMessage( id : word);
    procedure Quit;
    property  POPError: boolean read FPOPError;
    property  ErrorString: string read FPOPErrorString;
    property  MsgsCount: word read FMsgsCount;
    property  SessionState: TSessionState read FSessionState;
    property  Connected: boolean read FConnected;
    property  ReplyCode: string read FReplyCode;
    property  ReplyString: string read FReplyString;
    property  Canceled: boolean read FCanceled write FCanceled;
  published
    { Published declarations }
    property  UserId: string read FUserId write FUserId;
    property  Passwd: string read FPasswd write FPasswd;
    property  Port: string read FPort write FPort;
    property  Host: string read FHost write FHost;
    property  DecodeProgressStep: word read FDecodeProgressStep write FDecodeProgressStep;
    property  RetrieveProgressStep: word read FRetrieveProgressStep write FRetrieveProgressStep;
    property  OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
    property  OnQuit: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property  OnError: TOnError read FOnError write FOnError;
    property  OnDecodeStart: TOnCodeStartEvent read FOnDecodeStart write FOnDecodeStart;
    property  OnDecodeProgress: TOnCodeProgressEvent read FOnDecodeProgress write FOnDecodeProgress;
    property  OnDecodeEnd: TNotifyEvent read FOnDecodeEnd write FOnDecodeEnd;
    property  OnBeforeRetrieve: TOnBeforeRetrieve read FOnBeforeRetrieve write FOnBeforeRetrieve;
    property  OnAfterRetrieve: TNotifyEvent read FOnAfterRetrieve write FOnAfterRetrieve;
    property  OnRetrieveProgress: TOnCodeProgressEvent read FOnRetrieveProgress write FOnRetrieveProgress;
    property  OnDelete: TOnDeleteEvent read FOnDelete write FOnDelete;
  end;

  procedure register;




implementation
{ $R *.dcr }

uses Registry;

const crlf = #13#10;
      esErrorInFormatOfMsg = 'Error en el formato del mensaje.';  {*}
      esNotConnected = 'No conectado.';
      esInvalidOp = 'Operacin invlida.';
      esNotOrigin = 'No se especific el origen (aMsg.From)';
      esNotDestination = 'No se especific el destino (aMsg.SendTo)';
      // es = exception string
      // {*} this must be translated to your languaje,
      // the others are used only in design stage.

procedure Register;
begin
  RegisterComponents('Internet', [TSakPOP, TSakSMTP, TSakMsg, TSakMsgList]);
end;


{ ***************** TAttachedFile ***************** }

constructor TAttachedFile.create( Collection: TCollection);
begin
     inherited create( Collection);
end;

procedure TAttachedFile.SaveToFile( fn: string);
begin
     if FBodyBin = nil then Exception.create( esInvalidOp);
     FBodyBin.SaveToFile( fn);
end;


{ ***************** TAttachedFiles ***************** }

constructor TAttachedFiles.create( SakMsg: TSakMsg);
begin
     inherited create( TAttachedFile);
     FSakMsg := SakMsg;
end;

function TAttachedFiles.GetItem( index: integer): TAttachedFile;
begin
     result := TAttachedFile( inherited GetItem( index));
end;

procedure TAttachedFiles.SetItem( index: integer; value: TAttachedFile);
begin
     inherited SetItem( index, value);
end;

function TAttachedFiles.add( fn: string): TAttachedFile;
var
  attach: TAttachedFile;
begin
    attach := TAttachedFile( inherited Add);
    attach.FFileName := ExtractFileName( fn);
    attach.FMIMEType := FGetMIMEType( fn);
    result := attach;
end;

function TAttachedFiles.FGetMIMEType(const FileName : string) : string;
var
  Key : string;
begin
  Result:='';
  with TRegistry.Create do
  try
    RootKey:=HKEY_CLASSES_ROOT;
    Key:=ExtractFileExt(FileName);
    if KeyExists(Key) then
    begin
      OpenKey(Key,false);
      Result:=ReadString('Content Type');
      CloseKey;
    end;
  finally
    if Result='' then
      Result:='application/octet-stream';
    free;
  end;
end;


{ ***************** TSakMsg ***************** }

constructor TSakMsg.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FAttachedFiles := TAttachedFiles.create( self);
     FText := TStringList.create;
end;

destructor TSakMsg.destroy;
begin
     FAttachedFiles.free;
     inherited destroy;
end;

{ ***************** TSakMsgList ***************** }

constructor TSakMsgList.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     if not ( csDesigning in ComponentState) then
        FList := TList.create;
end;

destructor TSakMsgList.destroy;
begin
     if not ( csDesigning in ComponentState) then
        FList.destroy;
     inherited destroy;
end;

function  TSakMsgList.Get(Index: Integer): TsakMsg;
begin
     result := TSakMsg( FList.Items[ index]);
end;

procedure TSakMsgList.Put(Index: Integer; Item: TsakMsg);
begin
     FList.Items[ index] := Item;
end;

procedure TSakMsgList.Clear;
begin
     FList.Clear;
end;

function  TSakMsgList.Add(Item: TsakMsg): Integer;
begin
     result := FList.Add( Item);
end;

procedure TSakMsgList.Delete(Index: Integer);
begin
     FList.Delete( index);
end;

function  TSakMsgList.IndexOf(Item: TsakMsg): Integer;
begin
     result := FList.IndexOf( Item);
end;

procedure TSakMsgList.Insert(Index: Integer; Item: TsakMsg);
begin
     FList.Insert( Index, Item);
end;

function  TSakMsgList.Remove(Item: TsakMsg): Integer;
begin
     result := FList.Remove( Item);
end;

function  TSakMsgList.First: TSakMsg;
begin
     result := TSakMsg( FList.first);
end;

function  TSakMsgList.Last: TSakMsg;
begin
     result := TSakMsg( FList.Last);
end;

function  TSakMsgList.GetCount: integer;
begin
     result := FList.Count;
end;


{ ***************** TSakSMTP ***************** }

constructor TSakSMTP.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FConnected := false;
     FPort := '25';
     FEncodeProgressStep := 10;
     FSendProgressStep := 10;
     if not ( csDesigning in ComponentState) then
     begin
          FSocket := TClientSocket.create( AOwner);
          FSocket.ClientType := ctBlocking;
          FSocket.OnConnect := FDoConnect;
          FSocket.OnDisconnect := FDoDisconnect;
          FSocket.OnError := FDoError;
     end;
end;

procedure TSakSMTP.Connect;
begin
     FSocket.port := StrToInt( FPort);
     FSocket.host := FHost;

     FSMTPError := false;
     FSocket.Open;
     FSocketStream := TWinSocketStream.create( FSocket.Socket, 20);
                                                    // 20 = timeout
                                                    // not documented in D3.0
                                                    // but NEEDED !
     if FSMTPError then exit;

     while not FConnected do Application.ProcessMessages;
     FReceiveTextFromSocket;
     while (FReplyCode <> '220') and (FReplyCode <> '421') do
     begin
          FReceiveTextFromSocket;
          Application.ProcessMessages;
          if not FConnected then exit;
     end;
     FSMTPError := FReplyCode <> '220';
     if FSMTPError then
     begin
          FDoErr( eeConnect);
          exit;
     end;

     FSendTextToSocket( 'HELO ' + FSocket.Socket.LocalHost + crlf);
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
        FDoErr( eeConnect);
     FCanceled := False;
end;

procedure TSakSMTP.FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := true;
     if assigned( FOnConnect) then FOnConnect( Sender);
end;

procedure TSakSMTP.Quit;
begin
     if FConnected then
     begin
          if FCanceled
          then begin
                    FSocketStream.Free;
                    FSocket.close;
                    FConnected := false;
               end
          else begin
                    try
                         FSendTextToSocket( 'QUIT' +crlf);
                         FReceiveTextFromSocket;
                         FSMTPError := FReplyCode <> '221';
                         if FSMTPError then
                            FDoErr( eeDisconnect);
                      finally
                         FSocketStream.Free;
                         FSocket.close;
                         FConnected := false;
                    end
               end;
     end;
end;

function TSakSMTP.SendMessage( var aMsg: TSakMsg): boolean;
var i, cntTos : integer;
    msgTos : array[ 1..256] of string;
    TOs: string;
    StrListMsg: TStringList;
    step: word;
begin
     result := false;

     if not FConnected then
        Exception.create( esNotConnected);
     if aMsg.From = '' then
        Exception.create( esNotOrigin);
     if aMsg.SendTo = '' then
        Exception.create( esNotDestination);

     aMsg.FDate := FormatDateTime( 'ddd, d mmm yy tt', Now);
     StrListMsg := FPrepareText( aMsg);
     if FCanceled then exit;
     DoOnBeforeSend;
     FSendTextToSocket( 'MAIL FROM:' + '<' + aMsg.From + '>' + crlf);
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
     begin
          FDoErr( eeGeneral);
          exit;
     end;

     cntTos := 1;
     TOs := trim( aMsg.SendTo);
     i := pos( ',', TOs);
     while i > 0 do
     begin                          // to various addresses
          MsgTos[ cntTos] := trim( copy( TOs, 1, i -1));
          delete( TOs, 1, i);
          i := pos( ',', TOs);
          inc( cntTos);
     end;
     MsgTos[ cntTos] := TOs;

     for i := 1 to cntTos do
     begin
          FSendTextToSocket( 'RCPT TO:' + '<' + MsgTos[ i] + '>' +crlf);
          FReceiveTextFromSocket;
          FSMTPError := FReplyCode <> '250';
          if FSMTPError then
          begin
               FDoErr( eeGeneral);
               exit;
          end;
     end;

     FSendTextToSocket( 'DATA' +crlf);
     FReceiveTextFromSocket;
     FSMTPError := (FReplyCode <> '354'); // and (FReplyCode <> '250');
     if FSMTPError then
     begin
        FDoErr( eeGeneral);
        exit;
     end;

     step := FSendProgressStep;
     for i := 0 to StrListMsg.Count-1 do
     begin
          FSendTextToSocket( StrListMsg[ i] + crlf);
          FSendProgress := round( 100*i/StrListMsg.Count);
          if ( FSendProgress >= step) then
          begin
               FDoSendProgress( FSendProgress);
               inc( step, FSendProgressStep);
          end;
          Application.ProcessMessages;
          if FCanceled then exit;
          if odd(i) then Sleep( 1);
     end;
     FSendTextToSocket( crlf + '.' + crlf);     // end of msg
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
     begin
          FDoErr( eeGeneral);
          exit;
     end;
     if FSendProgress < 100 then FDoSendProgress( 100);
     result := true;
     DoOnAfterSend;
end;


function TSakSMTP.FPrepareText( var aMsg: TSakMsg): TStringList;
var i: integer;
    boundary, UsrName: string;
    body, Headers: TStringList;
    AttFile: TAttachedFile;
begin
     result := nil;
     Headers := TStringList.Create;
     Body := TStringList.Create;

     Body.Text := aMsg.Text.Text;

     i := Body.IndexOf( '.');
     while (i <> -1) do
     begin
          if (Body[i-1] = '') and (Body[i+1] = '') then Body[i] := '..';
          i := Body.IndexOf('.');              // agregamos transparency
     end;

     UsrName := AMsg.UserName;

     Headers.Add('Message-Id: ' + FMakeUniqueId);
     if aMsg.InReplyTo <> '' then Headers.Add('In-Reply-To: ' + aMsg.InReplyTo);
     Headers.Add('Date: ' + aMsg.Date);
     if UsrName <> '' then begin
                                if (pos( '@', aMsg.From) = 0)
                                then Headers.Add('From: ' + '"' + UsrName + '" <' +
                                                  aMsg.From + '@' + Host + '>')
                                else Headers.Add('From: ' + '"' + UsrName + '" <' +
                                                  aMsg.From + '>');
                           end
                      else Headers.Add('From: ' + aMsg.From);
     if aMsg.ReplyTo <> '' then Headers.Add('Reply-To: ' + aMsg.ReplyTo);
     Headers.Add('X-Mailer: ' + Application.Title);
     Headers.Add('To: ' + aMsg.SendTo);
     Headers.Add('Subject: ' + aMsg.Subject);
     Headers.Add('MIME-Version: 1.0');

     if aMsg.attachedFiles.count = 0 then
     begin
          Headers.Add( 'Content-Type: Text/Plain; charset=ISO-8859-1');
          Headers.Add( 'Content-Transfer-Encoding: 8bit');
     end;

     if aMsg.attachedFiles.count > 0 then
     begin
        boundary := FGenerateBoundary;
        Headers.Add( 'Content-Type: multipart/mixed; boundary="' + boundary + '"');
        boundary := '--' + boundary;
        Body.Insert( 0, boundary);
        Body.Insert( 1, 'Content-Type: Text/Plain; charset: ISO-8859-1');
        Body.Insert( 2, 'Content-Transfer-Encoding: 8bit');
        Body.Insert( 3, '');
        for i := 0 to aMsg.attachedFiles.count-1 do
        begin
             AttFile := aMsg.AttachedFiles[ i];
             Body.Add( boundary);
             Body.Add( 'Content-Type: ' + AttFile.MIMEType +
                       '; name="' + AttFile.fileName + '"');
             Body.Add( 'Content-Transfer-Encoding: base64');
             Body.Add( 'Content-Disposition: inline; filename="' +
                       aMsg.AttachedFiles[ i].fileName + '"');
             Body.Add( '');
             Base64Encode( AttFile);
             if FCanceled then exit;
             Body.AddStrings( AttFile.FBodyEncoded);
        end;
        Body.Add( '');
        Body.Add( boundary + '--');
        Body.Add( '');
     end;

     Application.ProcessMessages;
     if FCanceled then exit;
     result := TStringList.Create;
     result.AddStrings( Headers);
     result.Add( '');
     result.AddStrings( Body);
     Headers.Free;
     Body.Free;
end;


function TSakSMTP.FMakeUniqueID : string;
var s: string;
    i : Integer;
    Year, Month, Day: Word;
begin
  Randomize;
  s := '';
  for i:=1 to 8 do
    s := Concat( s, chr( 97 + Random(20)));
  DecodeDate( Now, Year, Month, Day);
  result := '<' + 'SAK.' +  IntToStr(Day) + '.' + IntToStr(Month) + '.' +
            IntToStr(Year) + '.' + s + '@' + FSocket.Socket.LocalHost + '>';
end;

procedure TSakSMTP.Base64Encode( var AttachedFile: TAttachedFile);
const _Code64: string[64] =
      ('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/');
var
   i, BytesCoded: longint;
   b: array[0..2279] of byte;
   j,k,l,m, quads, step: integer;
   stream: string[76];
   TextCoded: TStringList;
   TextBin: TFileStream;
begin
     TextBin := TFileStream.Create( AttachedFile.FileName, fmOpenRead or fmShareDenyNone);
     FDoEncodeStart( AttachedFile.FileName, TextBin.Size);
     TextCoded := TStringList.Create;
     stream := '';
     step := FEncodeProgressStep;
     BytesCoded := 0;
     quads := 0;
     j := TextBin.Size div 2280;
     for i := 1 to j do
     begin
          Application.ProcessMessages;
          if FCanceled then exit;
          TextBin.Read( b, 2280);
          for m:=0 to 39 do
          begin
               for k:=0 to 18 do
               begin
                    l:=57*m+3*k;
                    stream[quads+1]:=_Code64[(b[l]div 4)+1];
                    stream[quads+2]:=_Code64[(b[l] mod 4)*16 +(b[l+1] div 16)+1];
                    stream[quads+3]:=_Code64[(b[l+1] mod 16)*4 +(b[l+2] div 64)+1];
                    stream[quads+4]:=_Code64[b[l+2] mod 64+1];
                    Inc(quads,4);
                    if quads=76 then
                    begin
                         stream[0]:=#76;
                         TextCoded.Add( stream);
                         inc( BytesCoded, 57);
                         FEncodeProgress := round( 100*BytesCoded/TextBin.Size);
                         if ( FEncodeProgress >= step) then
                         begin
                              FDoEncodeProgress( FEncodeProgress);
                              inc( step, FEncodeProgressStep);
                         end;
                         Application.ProcessMessages;
                         quads:=0;
                    end;
               end;
          end;
     end;
     j:= (TextBin.Size mod 2280) div 3;
     for i:=1 to j do
     begin
          Application.ProcessMessages;
          if FCanceled then exit;
          TextBin.Read( b, 3);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +(b[1] div 16)+1];
          stream[quads+3]:=_Code64[(b[1] mod 16)*4 +(b[2] div 64)+1];
          stream[quads+4]:=_Code64[b[2] mod 64+1];
          Inc(quads,4);
          if quads=76 then
          begin
               stream[0]:=#76;
               TextCoded.Add( stream);
               quads:=0;
          end;
     end;
     if (TextBin.Size mod 3) = 2 then
     begin
          TextBin.Read( b, 2);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +(b[1] div 16)+1];
          stream[quads+3]:=_Code64[(b[1] mod 16)*4 +1];
          stream[quads+4]:='=';
          Inc(quads,4);
     end;
     if (TextBin.Size mod 3) = 1 then
     begin
          TextBin.Read( b, 1);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +1];
          stream[quads+3]:='=';
          stream[quads+4]:='=';
          Inc(quads,4);
     end;
     TextBin.Free;
     stream[0]:=Chr(quads);
     if quads > 0 then TextCoded.Add( stream);
     if FEncodeProgress < 100 then FDoEncodeProgress( 100);
     Application.ProcessMessages;
     if FCanceled then exit;
     AttachedFile.FBodyEncoded := TextCoded;
     FDoEncodeEnd;
end;

function TSakSMTP.FGenerateBoundary : string;
var s: string;
    i : integer;
begin
     randomize;
     s := '';
     for i := 1 to 12 do
         s := s + chr( 97 + random( 25));
     result := '--_SAK_bound_' + s;
end;

procedure TSakSMTP.FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := false;
     if assigned( FOnDisconnect) then FOnDisconnect( Sender);
end;


function TSakSMTP.FReceiveTextFromSocket: string;
var s: string;
    i, x : integer;
    buff: array[1..1024] of char;
begin
     repeat
           while not FSocketStream.WaitForData( 200) do Application.ProcessMessages;
           x := FSocketStream.read( buff, 1024);
           s := copy( buff, 1, x);
           i := pos( crlf, s);
           if (i > 0) and (length( s) > i+2) then s := copy( s, i+2, 64);
           FReplyCode := trim( copy( s, 1, 3));          // this is for you, Serge :)
           FReplyString := trim( copy( s, 4, 64));
           result := s;
           Application.ProcessMessages;
           if s = '' then s := '----';
     until s[4] = ' ';
end;

procedure TSakSMTP.FSendTextToSocket( const txt: string);
begin
     FSocketStream.write( Pointer( txt)^, length( txt));
end;

procedure TSakSMTP.DoOnBeforeSend;
begin
     if assigned( FOnBeforeSend) then FOnBeforeSend( self);
end;

procedure TSakSMTP.DoOnAfterSend;
begin
     if assigned( FOnAfterSend) then FOnAfterSend( self);
end;

procedure TSakSMTP.FDoErr( ErrorEvent: TErrorEvent);
var x: integer;
begin
     x := 0;
     FDoError( self, FSocket.Socket, ErrorEvent, x);
end;

procedure TSakSMTP.FDoError( Sender: TObject; Socket: TCustomWinSocket;
                             ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
     FSMTPError := true;
     FSocketStream.Free;
     FSocket.close;
     FConnected := false;
     if assigned( FOnError) then FOnError( Sender, StrToInt( FReplyCode), FReplyString);
end;

procedure TSakSMTP.FDoEncodeStart( FileName: string; Size: longint);
begin
     if assigned( FOnEncodeStart) then FOnEncodeStart( self, FileName, Size);
end;

procedure TSakSMTP.FDoEncodeProgress( Percent: word);
begin
     if assigned( FOnEncodeProgress) then FOnEncodeProgress( self, Percent);
end;

procedure TSakSMTP.FDoEncodeEnd;
begin
     if assigned( FOnEncodeEnd) then FOnEncodeEnd( self);
end;

procedure TSakSMTP.FDoSendProgress( Percent: word);
begin
     if assigned( FOnSendProgress) then FOnSendProgress( self, Percent);
end;


{ ***************** TSakPOP ***************** }

constructor TSakPOP.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FConnected := false;
     FPort := '110';
     FDecodeProgressStep := 10;
     FRetrieveProgressStep := 10;
     FReceivingMsg := false;
     if not ( csDesigning in ComponentState) then
     begin
          FSocket := TClientSocket.create( AOwner);
          FSocket.ClientType := ctBlocking;
          FSocket.OnConnect := FDoConnect;
          FSocket.OnDisconnect := FDoDisconnect;
          FSocket.OnError := FDoError;
     end;
end;

procedure TSakPOP.Connect;
begin
     FMessagesDeleted := TStringList.create;
     FMsgsCount := 0;
     FSocket.port := StrToInt( FPort);
     FSocket.host := FHost;
     FSocket.Open;
     if FConnected then
     begin
          FSocketStream := TWinSocketStream.create( FSocket.Socket, 100);
          FReceiveTextFromSocket;
          FSessionState := Authorization;
          FCanceled := False;
          if FPOPError then FDoErr( 2000);
     end;
end;

procedure TSakPOP.FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := true;
     if assigned( FOnConnect) then FOnConnect( Sender);
end;

function TSakPOP.Login: boolean;
begin
     result := false;
     if not FConnected then
        Exception.create( 'Op. invlida. Aun no conectado');

     FSendTextToSocket( 'USER ' + UserId +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2001); exit; end;

     FSendTextToSocket( 'PASS ' + passwd +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2001); exit; end;

     result := true;
     FSessionState := Transaction;
end;

function TSakPOP.Init: word;
var i: integer;
begin
     result := 0;
     FSendTextToSocket( 'STAT' +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2006); exit; end;

     i := pos( ' ', FReplyString);
     FMsgsCount := strToInt( copy( FReplyString, 1, i-1));

     FSendTextToSocket( 'LAST' + crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2001); exit; end;

     i := pos( ' ', FReplyString);
     if i > 0 then FReplyString := copy( FReplyString, 1, i-1);
     result := FMsgsCount - strToInt( FReplyString);
end;

procedure TSakPOP.Quit;
begin
     if FConnected then
        begin
             FSendTextToSocket( 'QUIT' +crlf);
             FReceiveTextFromSocket;
             if FPOPError then FDoErr( 2002)
                          else begin
                                 FMessagesDeleted.free;
                                 FSocketStream.Free;
                                 FSocket.close;
                                 FConnected := false;
                               end;
        end;
end;

procedure TSakPOP.DeleteMessage( id : word);
begin
     if not FConnected then
        Exception.create( esNotConnected);

     Application.ProcessMessages;
     if FCanceled then exit;

     FSendTextToSocket( 'DELE ' + intToStr( id) +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2003); exit; end;

     FMessagesDeleted.Add( intToStr( id));
     dec( FMsgsCount);
     FDoDelete( id);
end;

function TSakPOP.RetrieveMessage( id : word): TSakMsg;
const EOM = crlf+'.'+crlf;
var i, p, x, line, position: integer;
    s, boundary, endOfMsg, CTEncoding, ContType, FileName: string;
    sakMsg: TSakMsg;
    Headers, HeadersPart, aPart, StrListMsg: TStringList;
    Partes: TList;
    AttFile: TAttachedFile;
    AllMsg: TMemoryStream;
    found: boolean;
begin
     result := nil;
     if not FConnected then
        Exception.create( esNotConnected);

     FDoBeforeRetrieve( id);

     AllMsg := TMemoryStream.Create;

     FSendTextToSocket( 'RETR ' + intToStr( id) + crlf);
     s := FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2004); exit; end;

     if FReplyString <> '' then begin
                                     try
                                        FSize := strToInt( copy( FReplyString, 1, pos( ' ', FReplyString)-1));
                                      except
                                        FSize := 100;
                                     end;
                                end
                           else FSize := 100;

     FStep := FRetrieveProgressStep;

     AllMsg.Write( Pointer( s)^, length( s));
     while pos( EOM, s) = 0 do
     begin
          Application.ProcessMessages;
          if FCanceled then begin
                                result := nil;
                                exit;
                            end;
          s := copy( s, length( s)-3, 4) + FReceiveTextFromSocket;
          AllMsg.Write( s[5], length( s)-4);
          FRetrieveProgress := round( 100*AllMsg.size/FSize);
          if ( FRetrieveProgress >= FStep) then
          begin
               FDoRetrieveProgress( FRetrieveProgress);
               inc( FStep, FRetrieveProgressStep);
          end;
     end;

     if FRetrieveProgress < 100 then FDoRetrieveProgress( 100);

     StrListMsg := TStringList.Create;
     StrListMsg.text := PChar( AllMsg.Memory);
     StrListMsg.Delete( 0);
     StrListMsg.delete( StrListMsg.count-1);             // borro el EOM

     { -- begin of parsing -- :( }
     Headers := TStringList.create;
     sakMsg := TSakMsg.create( self);

     i := StrListMsg.IndexOf( '');
     if i <> -1 then for p := 0 to i do headers.Add( StrListMsg[p]);

     for p := 0 to i do StrListMsg.delete( 0);
     i := StrListMsg.IndexOf( '..');
     while i > -1 do
     begin
          StrListMsg[ i] := '.';              // saco transparency
          i := StrListMsg.IndexOf( '..');
     end;

     sakMsg.From := copy( Headers.strings[0], 6, 72);

     found := FindInHeaders( 'FROM:', Headers, line);
     if found then
     begin
          sakMsg.FFrom := trim( copy( Headers[ line], 7, 127));
          x := 1;
          if (Headers[line+x] <> '') then
          while Headers[line+x][1] = ' ' do
          begin
               sakMsg.FFrom := sakMsg.FFrom + trim( Headers[line+x]);
               inc( x);
          end;
     end;
     // he encontrado casos en que ocupa mas de una linea  >:|

     found := FindInHeaders( 'MESSAGE-ID:', Headers, line);
     if found then sakMsg.FMessageId := trim( copy( Headers[ line], 13, 127));

     found := FindInHeaders( 'IN-REPLY-TO:', Headers, line);
     if found then sakMsg.FInReplyTo := trim( copy( Headers[ line], 14, 127));

     found := FindInHeaders( 'REPLY-TO:', Headers, line);
     if found then
     begin
          sakMsg.FReplyTo := copy( Headers[ line], 11, 127);
          x := 1;
          if (Headers[line+x] <> '') then
          while Headers[line+x][1] = ' ' do
          begin
               sakMsg.FReplyTo := sakMsg.FReplyTo + trim( Headers[line+x]);
               inc( x);
          end;
     end;

     found := FindInHeaders( 'TO:', Headers, line);
     if found then
     begin
          sakMsg.FSendTo := trim( copy( Headers[ line], 5, length( Headers[ line])-3));
          x := 1;
          if (Headers[line+x] <> '') then
          while Headers[line+x][1] = ' ' do
          begin
               sakMsg.FSendTo := sakMsg.FSendTo + ' ' + trim( Headers[line+x]);
               inc( x);
          end;
     end;

     found := FindInHeaders( 'DATE:', Headers, line);
     if found then sakMsg.FDate := trim( copy( Headers[ line], 7, 72));

     found := FindInHeaders( 'SUBJECT:', Headers, line);
     if found then sakMsg.FSubject := Trim( copy( Headers[ line], 10, length( Headers[ line])));

     found := FindInHeaders( 'CONTENT-TYPE:', Headers, line);
     if found then
     begin
          ContType := upperCase( Trim( copy( Headers[ line], 15, 72)));
          x := pos( ';', ContType);
          if x > 0 then ContType := copy( ContType, 1, x-1);
     end;

     if not found or (pos( 'TEXT', ContType) > 0) or
        (ContType = 'MULTIPART/REPORT') or
        (pos( 'MESSAGE', ContType) > 0) then
     begin
          {search for UUcoded files}
          Partes := TList.create;
          while FindUUAttachs( StrListMsg, line, FileName) do
          begin
               aPart := TStringList.create;
               Partes.add( aPart);
               while lowercase( trim( StrListMsg[ line])) <> 'end' do
               begin
                    if StrListMsg[ line] <> '' then aPart.Add( StrListMsg[ line]);
                    StrListMsg.Delete( line);
               end;
               sakMsg.attachedFiles.add( FileName);
               AttFile := sakMsg.attachedFiles[ sakMsg.attachedFiles.count-1];
               AttFile.FBodyEncoded := TStringList.create;
               AttFile.FBodyEncoded.Assign( aPart);
               UUDecode( AttFile);
               aPart.Free;
          end;
          Partes.Free;
          sakMsg.FText.Text := StrListMsg.text;
          result := sakMsg;
          FDoAfterRetrieve;
          exit;
     end;


     // this only if is multipart/mixed or some variant

     found := FindInStringList( 'BOUNDARY=', Headers, line, position);
     if not found then raise Exception.Create( esErrorInFormatOfMsg);

     s := Headers.strings[ line];
     boundary := trim( copy( s, position + 9, 72));
     if boundary[1] = '"' then
     begin
          delete( boundary, 1, 1);
          x := pos( '"', boundary);      //sometimes there are a ; in the end
          delete( boundary, x, 32);
     end;
     boundary := '--' + boundary;
     endOfMsg := boundary + '--';
     Partes := TList.create;
     aPart := TStringList.create;

     found := FindInStringListCS( boundary, StrListMsg, line, position);
     if not found then raise Exception.Create( esErrorInFormatOfMsg);

     inc( line);
     while StrListMsg[ line] <> endOfMsg do
     begin
          if StrListMsg[ line] = boundary then
          begin
               Partes.add( aPart); // agregar aPart.free;
               aPart := TStringList.create;
               inc( line);
          end;
          aPart.add( StrListMsg[ line]);
          inc( line);
     end;

     Partes.add( aPart); //agregar aPart.free;

     for p := 0 to Partes.count-1 do
     begin
       aPart := TStringList( partes[ p]);

       HeadersPart := TStringList.Create;
       i := 0;
       while aPart[i] <> '' do begin
                                    HeadersPart.Add( aPart[i]);
                                    inc( i);
                               end;
       found := FindInHeaders( 'CONTENT-TRANSFER-ENCODING:', HeadersPart, line);
       if found then CTEncoding := uppercase( trim( copy( HeadersPart[ line], 28, 20)))
                else CTEncoding := '';

       found := FindInHeaders( 'CONTENT-TYPE:', HeadersPart, line);
       if found then begin ContType := upperCase( Trim( copy( HeadersPart[ line], 15, 72)));
                           x := pos( ';', ContType);
                           if x > 0 then ContType := copy( ContType, 1, x-1);
                     end
                else ContType := '';

       FileName := '';
       found := FindInStringList( 'FILENAME=', HeadersPart, line, position);
       if found
       then begin FileName := trim( copy( HeadersPart[ line], position+10, 127));
                  delete( FileName, length( FileName), 1);
            end
       else begin
                 found := FindInStringList( 'NAME=', HeadersPart, line, position);
                 if found
                 then begin
                           FileName := trim( copy( HeadersPart[ line], position+5, 127));
                           if FileName[ 1] = #34 then
                           begin
                                delete( FileName, 1, 1);
                                delete( FileName, length( FileName), 1);
                           end;
                      end;
            end;

       HeadersPart.Free;

       if (CTEncoding = 'BASE64') or (FileName <> '') or (ContType = 'TEXT/HTML') or
          (CTEncoding = 'X-UUENCODE')
       then begin
                 if FileName = '' then FileName := trim( SakMsg.Subject);
                 if FileName = '' then FileName := '_Cosa_';
                 if ContType = 'TEXT/HTML' then FileName := FileName + '.html';
                 sakMsg.attachedFiles.add( FileName);

                 while (trim(aPart[ 0]) <> '') do aPart.delete( 0);
                 if (CTEncoding = 'BASE64') or (CTEncoding = 'X-UUENCODE')
                    then while trim( aPart[ 0]) = '' do aPart.delete( 0)
                    else aPart.Delete( 0);
                 AttFile := sakMsg.attachedFiles[ sakMsg.attachedFiles.count-1];
                 if CTEncoding ='BASE64'
                 then begin
                           AttFile.FBodyEncoded := TStringList.create;
                           AttFile.FBodyEncoded.Assign( aPart);
                           Base64Decode( AttFile);
                      end
                 else if CTEncoding ='X-UUENCODE'
                      then begin
                                AttFile.FBodyEncoded := TStringList.create;
                                AttFile.FBodyEncoded.Assign( aPart);
                                UUDecode( AttFile);
                           end
                      else begin
                                aPart.delete( aPart.count -1);
                                AttFile.FBodyBin := TMemoryStream.create;
                                AttFile.FBodyBin.Write( Pointer( aPart.text)^, length( aPart.text));
                           end;
            end
       else begin
                 while aPart[ 0] <> '' do aPart.delete( 0);
                 aPart.delete( 0);
                 sakMsg.Text.AddStrings( aPart);
            end;
     end;
     Partes.Free;
     result := sakMsg;
     FDoAfterRetrieve;
end;

function TSakPOP.RetrieveAllMessages( var SakMsgList: TSakMsgList): integer;
var i, count: integer;
    aSakMsg: TSakMsg;
begin
     SakMsgList.clear;
     count := 0;
     for i := 1 to FMsgsCount do
     begin
         if FMessagesDeleted.IndexOf( intToStr( i)) = -1 then
         begin
              aSakMsg := RetrieveMessage( i);
              if FCanceled then break
                           else begin
                                     SakMsgList.add( aSakMsg);
                                     inc( count);
                                end;
         end;
     end;
     result := count;
end;

function TSakPOP.RetrieveHeaders( id : word): string;
const EOM = crlf+'.'+crlf;
var   s: string;
begin
     if not FConnected then
        Exception.create( esNotConnected);

     FSendTextToSocket( 'TOP ' + intToStr( id) + ' 0'+crlf);
     s := FReceiveTextFromSocket;
     if not FPOPError then
        begin
             delete( s, 1, pos( crlf, s));
             result := s;
             while pos( EOM, s) = 0 do
             begin
                  s := FReceiveTextFromSocket;
                  result := result + s;
             end;
        end
     else
        FDoErr( 2005);
end;


procedure TSakPOP.Base64Decode( var AttachedFile: TAttachedFile);
var
   a1: array[1..4] of byte;
   b1: array[1..3] of byte;
   i, j, step:  integer;
   byte_ptr,real_bytes: integer;
   buff: TMemoryStream;
   Txt: TStringList;
   line: string;
begin
     Txt := AttachedFile.FBodyEncoded;
     FDoDecodeStart( AttachedFile.FileName, Txt.Count);
     step := FDecodeProgressStep;
     buff := TMemoryStream.create;
     byte_ptr:=0;
     for i := 0 to Txt.Count-1 do
     begin
          line := Txt[i];
          for j := 1 to Length( line) do
          begin
               Inc( byte_ptr);
               case line[j] of
                    'A'..'Z': a1[byte_ptr] := Ord( line[j])-65;
                    'a'..'z': a1[byte_ptr] := Ord( line[j])-71;
                    '0'..'9': a1[byte_ptr] := Ord( line[j])+4;
                    '+': a1[byte_ptr] := 62;
                    '/': a1[byte_ptr] := 63;
                    '=': a1[byte_ptr] := 64;
               end;
               if byte_ptr = 4 then
               begin
                    byte_ptr := 0;
                    real_bytes := 3;
                    if a1[1] = 64 then real_bytes:=0;
                    if a1[3] = 64 then
                    begin
                         a1[3] := 0;
                         a1[4] := 0;
                         real_bytes := 1;
                    end;
                    if a1[4]=64 then
                    begin
                         a1[4] := 0;
                         real_bytes := 2;
                    end;
                    b1[1] := a1[1]*4+(a1[2] div 16);
                    b1[2] := (a1[2] mod 16)*16+(a1[3]div 4);
                    b1[3] := (a1[3] mod 4)*64 +a1[4];
                    buff.Write( b1, real_bytes);
                    FDecodeProgress := Round(100*i/Txt.Count);
                    if ( FDecodeProgress >= step) then
                    begin
                         FDoDecodeProgress( FDecodeProgress);
                         inc( step, FDecodeProgressStep);
                    end;
                    Application.ProcessMessages;
               end;
          end;
     end;
     AttachedFile.FBodyBin := buff;
     AttachedFile.FBodyEncoded.free;
     if FDecodeProgress < 100 then FDoDecodeProgress( 100);
     FDoDecodeEnd;
end;


procedure TSakPOP.UUDecode( var AttachedFile: TAttachedFile);
const Table = '`!"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_';
var
   A45Bytes: array[1..45] of byte;
   A24Bits: array[0..8*45] of boolean;
   i,j,k,b,m, BytesGenerated, step : word;
   ndx : LongInt;
   Txt: TStringList;
   line: string;
   LineLen, ActualLen : byte;
   buff: TMemoryStream;

function ByteFromTable(Ch : Char) : byte;
var n: byte;
begin
     n := 1;
     while (Ch<>Table[n]) and (n<=64) do Inc(n);
     if n > 64 then
     begin
          if Ch=' ' then Result := 0
                    else raise Exception.Create( esErrorInFormatOfMsg);
     end;
     Result := n-1;
end;

begin
     Txt := AttachedFile.FBodyEncoded;
     FDoDecodeStart( AttachedFile.FileName, Txt.Count);
     step := FDecodeProgressStep;
     buff := TMemoryStream.create;
     try
        ndx := 1;  { the first line (0) is 'begin 6xx bla bla'}
        repeat
              line := Txt.Strings[ ndx];

              FillChar( A45Bytes, 45, 0);
              FillChar( A24Bits, 8*45+1, 0);
              k:=0;
              LineLen := length( line);
              ActualLen := 4*ByteFromTable( line[1]) div 3;
              if ActualLen <> (4*45 div 3) then ActualLen := LineLen-1;
              for i:=2 to ActualLen+1 do
              begin
                   b:=ByteFromTable( line[i]);
                   for j:=5 DownTo 0 do
                   begin
                        m:=1 shl j;
                        if (b and m = m) then A24Bits[k]:=true;
                        Inc(k);
                   end;
              end;
              k:=0;
              for i:=1 to 45 do
              begin
                   b:=0;
                   for j:=7 DownTo 0 do
                   begin
                        if A24Bits[k] then b:= b or (1 shl j);
                        Inc(k);
                   end;
                   A45Bytes[i] := b;
              end;
              BytesGenerated:=ByteFromTable( line[1]);

              Buff.Write( A45Bytes, BytesGenerated);
              FDecodeProgress := Round(100*ndx/Txt.Count);
              if ( FDecodeProgress >= step) then
              begin
                   FDoDecodeProgress( FDecodeProgress);
                   inc( step, FDecodeProgressStep);
              end;
              Application.ProcessMessages;
              Inc( ndx);
        until (ndx = Txt.Count) or (Txt[ndx] = 'end')
              or (Txt[ndx] = Table[1]);
     finally
        AttachedFile.FBodyBin := buff;
        AttachedFile.FBodyEncoded.free;
        if FDecodeProgress < 100 then FDoDecodeProgress( 100);
        FDoDecodeEnd;
     end;
end;

function  TSakPOP.FindUUAttachs( const strList: TStringList;
                                 var line: integer;
                                 var FileName: string): boolean;
var s, que, permiss: string;
    position, intPermiss: integer;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;
     que := 'begin';
     repeat
           s := lowerCase( strList[ line]);
           position := pos( que, s);
           if position = 1 then
              if length( s) > 10 then   { begin 600 n}
              begin
                permiss := copy( s, 7, 3);
                try
                   intPermiss := StrToInt( permiss);
                 except
                   inc( line);
                   continue;
                end;
                if intPermiss < 777 then
                begin
                     FileName := copy( strList[ line], 11, 64);
                     result := true;
                     break;
                end;
              end;
           inc( line);
     until line = strList.count;
end;


function  TSakPOP.FindInHeaders( const que: string; const strList: TStringList;
                                 var line: integer): boolean;
var s: string;
    position: integer;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;                  // the method find of TStringList is useless in this case
     repeat
           s := upperCase( strList[ line]);
           position := pos( que, s);
           if position = 1 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

function  TSakPOP.FindInStringList( const que: string; const strList: TStringList;
                                    var line, position: integer): boolean;
var s: string;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;                  // the method find of TStringList is useless in this case
     repeat
           s := upperCase( strList[ line]);
           position := pos( que, s);
           if position > 0 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

function  TSakPOP.FindInStringListCS( const que: string; const strList: TStringList;
                                      var line, position: integer): boolean;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;
     repeat
           if pos( que, strList[line]) > 0 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

procedure TSakPOP.FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := false;
     if assigned( FOnDisconnect) then FOnDisconnect( Sender);
end;

function TSakPOP.FReceiveTextFromSocket: string;
var s: string;
    x: integer;
    buff: array[1..1024] of char;
begin
     while not FSocketStream.WaitForData( 200) do Application.ProcessMessages;
     x := FSocketStream.read( buff, 1024);
     s := copy( buff, 1, x);
     FReplyCode := trim( copy( s, 1, 4));
     FReplyString := trim( copy( s, 5, pos( crlf, s) -5));
     FPOPError := FReplyCode = '-ERR';
     result := s;
end;

procedure TSakPOP.FSendTextToSocket( const txt: string);
begin
     FSocketStream.write( pchar( txt)^, length( txt));
end;

procedure TSakPOP.FDoErr( err: integer);
begin
     FDoError( self, FSocket.Socket, eeGeneral, err);
end;

procedure TSakPOP.FDoError( Sender: TObject; Socket: TCustomWinSocket;
                            ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
     FPOPError := true;
     FMessagesDeleted.free;
     FSocketStream.Free;
     FSocket.close;
     FConnected := false;
     if assigned( FOnError) then FOnError( Sender, ErrorCode, FReplyString);
end;

procedure TSakPOP.FDoDecodeStart( FileName: string; BytesCount: longint);
begin
     if assigned( FOnDecodeStart) then FOnDecodeStart( self, FileName, BytesCount);
end;

procedure TSakPOP.FDoDecodeProgress( Percent: word);
begin
     if assigned( FOnDecodeProgress) then FOnDecodeProgress( self, Percent);
end;

procedure TSakPOP.FDoDecodeEnd;
begin
     if assigned( FOnDecodeEnd) then FOnDecodeEnd( self);
end;

procedure TSakPOP.FDoBeforeRetrieve( id: word);
begin
     if assigned( FOnBeforeRetrieve) then FOnBeforeRetrieve( self, id);
end;

procedure TSakPOP.FDoAfterRetrieve;
begin
     if assigned( FOnAfterRetrieve) then FOnAfterRetrieve( self);
end;

procedure TSakPOP.FDoRetrieveProgress( Percent: word);
begin
     if assigned( FOnRetrieveProgress) then FOnRetrieveProgress( self, Percent);
end;

procedure TSakPOP.FDoDelete( id: word);
begin
     if assigned( FOnDelete) then FOnDelete( self, id);
end;

end.
